@echo off
rem vMix to Transport Stream for Portsdown (IQ Mode)
rem By Dave G8GKQ April 2017 based on an original by Chris mw0llk January 2015.
rem with thanks to Rob m0dts for the linux shell script on which this was based.

rem Set the IP address of your Portsdown TX here

set ip=192.168.2.111

rem Set your callsign here

set callsign=G8GKQ

rem Print banner
echo vMix MPEG-2 Video Encoder for the BATC Portsdown Transmitter
echo ============================================================
echo:
echo Start this script once vMix is running, then leave it running
echo:
echo This script is limited to exact SRs of 333kS, 1000kS, 2000kS and 4000kS
echo Set the SR and FEC, press Enter for default (previous) values
echo:

:requestSR
if X%SR%==X set SR=2000
set defSR=%SR%
set /p SR=Enter SR (333, 1000, 2000 or 4000) in KS (%SR%):

set _tempvar=0
if %SR%==333  set _tempvar=1
if %SR%==1000 set _tempvar=1
if %SR%==2000 set _tempvar=1
if %SR%==4000 set _tempvar=1
if NOT %_tempvar% EQU 1 goto :requestSR

if X%SR%==X set SR=%defSR%

:requestFEC
if X%FEC%==X set FEC=7/8
set defFEC=%FEC%
set /p FEC=Enter FEC in kS (%FEC%):

set _tempvar=0
if %FEC%==1/2 set _tempvar=1
if %FEC%==2/3 set _tempvar=1
if %FEC%==3/4 set _tempvar=1
if %FEC%==5/6 set _tempvar=1
if %FEC%==7/8 set _tempvar=1
if NOT %_tempvar% EQU 1 goto :requestFEC

if X%FEC%==X set FEC=%defFEC%

rem Save values for next time
rem If these lines cause errors your system may not support SETX
rem If so just comment them out (use rem)

if not %SR%==%defSR% setx SR "%SR%"
if not %FEC%==%defFEC% setx FEC "%FEC%"

rem Look up Video bit rate value for current SR/FEC 

if %SR%==333 (
  if %FEC%==1/2 set VIDRATE=428571
  if %FEC%==2/3 set VIDRATE=571429
  if %FEC%==3/4 set VIDRATE=642857
  if %FEC%==5/6 set VIDRATE=714286
  if %FEC%==7/8 set VIDRATE=750000
)
if %SR%==1000 (
  if %FEC%==1/2 set VIDRATE=740000
  if %FEC%==2/3 set VIDRATE=985178
  if %FEC%==3/4 set VIDRATE=1123900
  if %FEC%==5/6 set VIDRATE=1267153
  if %FEC%==7/8 set VIDRATE=1348148
)
if %SR%==2000 (
  if %FEC%==1/2 set VIDRATE=1657143
  if %FEC%==2/3 set VIDRATE=2209524
  if %FEC%==3/4 set VIDRATE=2485714
  if %FEC%==5/6 set VIDRATE=2761905
  if %FEC%==7/8 set VIDRATE=2900000
)
if %SR%==4000 (
  if %FEC%==1/2 set VIDRATE=3293837
  if %FEC%==2/3 set VIDRATE=4431279
  if %FEC%==3/4 set VIDRATE=5000000
  if %FEC%==5/6 set VIDRATE=5560000
  if %FEC%==7/8 set VIDRATE=5820000
)

set /a BUFSIZE=%VIDRATE% * 6 / 10 

echo Video bitrate for %SR% kS and FEC %FEC% is: %VIDRATE%
echo:
echo Press any key to start the TS stream
echo:

pause

start "Video Transport Stream to Portsdown" /high ^
C:\ffmpeg\bin\ffmpeg ^
-f dshow -i video="vMix Video" ^
-f dshow -i audio="vMix Audio" ^
-f mpeg2video -pix_fmt yuv420p -r 25 -s 768x576 -aspect 4:3 -qmin 2 -qmax 35 -b:v %VIDRATE% -minrate %VIDRATE% -maxrate %VIDRATE% -bufsize %BUFSIZE% ^
-acodec mp2 -ab 128k -ac 2 ^
-f mpegts -mpegts_original_network_id 1 -mpegts_transport_stream_id 1 -mpegts_service_id 1 -mpegts_pmt_start_pid 4096 -streamid 0:256 -streamid 1:257 -metadata service_provider="BATC" -metadata service_name=%callsign% ^
-y ^
udp://%ip%:10000?pkt_size=1316

